      __      __                                            __   __   ______
     /\ \  __/\ \                                          /\ \ /\ \ /\__  _\
     \ \ \/\ \ \ \     __     __     _____     ___     ___ \ `\`\/'/'\/_/\ \/
      \ \ \ \ \ \ \  /'__`\ /'__`\  /\ '__`\  / __`\ /' _ `\`\/ > <     \ \ \
       \ \ \_/ \_\ \/\  __//\ \L\.\_\ \ \L\ \/\ \L\ \/\ \/\ \  \/'/\`\   \_\ \__
        \ `\___x___/\ \____\ \__/.\_\\ \ ,__/\ \____/\ \_\ \_\ /\_\\ \_\ /\_____\
         '\/__//__/  \/____/\/__/\/_/ \ \ \/  \/___/  \/_/\/_/ \/_/ \/_/ \/_____/
                                       \ \_\
                                        \/_/
             __         ___
            /\ \__  __ /\_ \           __
      __  __\ \ ,_\/\_\\//\ \    __  _/\_\
     /\ \/\ \\ \ \/\/\ \ \ \ \  /\ \/'\/\ \
     \ \ \_\ \\ \ \_\ \ \ \_\ \_\/>  </\ \ \                                     
      \ \____/ \ \__\\ \_\/\____\/\_/\_\\ \_\
       \/___/   \/__/ \/_/\/____/\//\/_/ \/_/
# UtilXI 
[![Build Status](https://secure.travis-ci.org/aponxi/npm-utilxi.png?branch=master)](http://travis-ci.org/aponxi/npm-utilxi)

> UtilXI, a utility library extends underscore.

## Jump to Section

* [Getting Started](#getting-started)
* [Documentation](#documentation)
* [Release History](#release-history)
* [License](#license)
* [Tip Me ![](http://i.imgur.com/C0P9DIx.gif?1)](https://www.gittip.com/aponxi/)
* [Donate Me! ![](http://i.imgur.com/2tqfhMO.png?1)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=VBUW4M9LKTR62)

## Getting Started
[[Back To Top]](#jump-to-section)

### To install from npm:

```bash
npm install utilxi --save
```
### To download from github:

```bash
git clone git://github.com/aponxi/npm-utilxi.git
```
To Install dependencies go to directory you cloned the repository to and :

```bash
npm install
```

### Running Tests:


```bash
npm test
```

or 

```bash
grunt test
```



### Usage

#### On node projects:

After [installing from npm](#To-install-from-npm) just require utilxi via:

```javascript
var _ = require("utilxi")
```

#### On web:

After downloading the code, you only need `lib/utilxi.js` file to be on your website dir. Just add the script on your html file:

```html
 <script src="wherever/utilxi.js"></script>
```

then do:

```html
<script type="text/javascript">
_ = require("/src/utilxi.coffee");
</script>
```

## Documentation
[[Back To Top]](#jump-to-section)

### About Functions

There are two types of functions, ones that are available for client-side [web] and server-side [node]. The ones for client-side are also available for server-side.

[Underscore Functions](http://documentcloud.github.com/underscore/) and these:

### capitalize

_String_ capitalize ( _String_ word) `[web]`

Capitalizes the first letter of string. Takes `word` argument as `String` and returns capitalized `String`.

Usage:

```javascript
  console.log(_.capitalize("fabio"));
  // Fabio
```

### contrastingColor

_String_ contrastingColor ( _String or Array_ color) `[web]`

This was also taken from somewhere on web... Gosh I wish I've saved the urls for reference... This function tells if you should use black or white on the background color. Takes the `color` argument as `String` or `Array` and color can be a hex `String` or an `Array` of RGB values 0-255 such as `[255, 255, 255]`. Returns `"000"` or `"fff"` for black or white.

Usage

```coffeescript
# can either use "fff" or "ffffff"
background = "ffffff" # white background should get black

result = _.contrastingColor("ffffff") # result is "000"
console.log result # "000"

```

### hexToRGBArray

_Array_ hexToRGBArray (_String_ color) `[web]`

Taken from somewhere on web I can't recall, this function converts hex color to RGB color Array. The argument should be a 3 digit or 6 digit hex color as `String`. Returns an `Array` with Red Green Blue values as `integer`. 

Usage:

```coffeescript
  hex = "f5664c"
  result = _.hexToRGBArray hex
  console.dir result # [245,102, 76]
```

### merge

_Object_ merge( _Object_ left, _Object_ right) `[web]`

Taken from [deepmerge package by nrf110](https://github.com/nrf110/deepmerge), a function that deeply merges objects. Function returns the merged `Object`. Takes two arguments, left `Object` and right `Object`. Right side overwrites left side.

```javascript
// Usage
var x = { foo: { bar: 3 },
  array: [ { does: 'work', too: [ 1, 2, 3 ] },{ really: 'yes' } ] }
var y = { foo: { baz: 4 },
  quux: 5,
  array: [ { does: 'work', too: [ 3,4, 5, 6 ] }, { really: 'ysee' } ] }

  _.merge(x,y)
// would result
{
    "foo": {
        "bar": 3,
        "baz": 4
    },
    "array": [
        {
            "does": "work",
            "too": [
                1,
                2,
                3,
                3,
                4,
                5,
                6
            ]
        },
        {
            "really": "ysee"
        }
    ],
    "quux": 5
}
```

### root

_String_ root() `[node]`

Gives the root directory of the node project, absolutely. Takes no arguments and returns the directory as `String`.

Usage:

```javascript
console.log(_.root());
// /home/logan/projects/npm-utilxi
```

### urlGetStatusCode

_void_ urlGetStatusCode ( _String_ url, _function_ callback( _int_ responseCode)) `[node]`

Makes a request to the web address and calls the callback function with the http response code.

Usage:

```coffeescript
    _.urlGetStatusCode "http://www.google.com/index.html", (code)->
        console.log code #200
    _.urlGetStatusCode "http://www.google.com/indexaaaa.html", (code)->
        console.log code #404
```


### urlGetStatusCodeReadable

_void_ urlGetStatusCodeReadable ( _String_ url, _function_ callback( _String_ responseString)) `[node]`

Makes a request to the web address and calls the callback function with the http response code.

Usage:

```coffeescript
    _.urlGetStatusCodeReadable "http://www.google.com/index.html", (code)->
        console.log code #OK
    _.urlGetStatusCodeReadable "http://www.google.com/indexaaaa.html", (code)->
        console.log code #Not Found
```



## Release History
[[Back To Top]](#jump-to-section)

You can find [all the changelogs here](/changelogs).

### Latest changelog is from v1.4.0.md:

#### 02/July/2013 v1.4
* Added url functions
* can get response code of the url in readable format or integer like 404 for Not Found
* Added documentation
* Removed browserify and other packages to make it node-only plug-in

## License
[[Back To Top]](#jump-to-section)

Copyright © 2013 aponxi <info@weaponxi.com>

This software is licensed under [MIT License](http://aponxi.mit-license.org/).



--------
<small>_This readme has been automatically generated by [readme generator](https://github.com/aponxi/grunt-readme-generator) on Tue Jul 02 2013 08:24:49 GMT-0400 (EDT)._</small>