_ = require "underscore"
http = require 'http'
# throw_error = () -> 
#   throw Error "This function is only for nodejs" unless typeof module isnt "undefined"
#   console.dir module
#   return

methods = 
  capitalize: (word) ->
    word.charAt(0).toUpperCase() + word.substring(1).toLowerCase();

  merge: (target, src) ->
    array = Array.isArray src
    dst = array and [] or {}
    if array
      target = target or []
      dst = dst.concat target

      src.forEach(
        (e,i) ->
          if typeof e is 'object' then dst[i] = methods.merge target[i], e
          else
            if target.indexOf e is -1 then dst.push e
        )
    else
      if target and typeof target is 'object'
        Object.keys(target).forEach(
            (key) ->
              dst[key] = target[key]
          )
      Object.keys(src).forEach(
          (key) ->
            if typeof src[key] isnt 'object' or not src[key]
              dst[key] = src[key]
            else
              if not target[key] then dst[key] = src[key]
              else dst[key] = methods.merge target[key], src[key]
        )
    dst
    
  root : () -> 
    # throw_error()
    path = require "path"
    path.resolve __dirname+"/../"

  hexToRGBArray : (color) ->
    if color[0] is "#" then color = color.slice(1)

    if color.length is 3
      color = color.charAt(0) + color.charAt(0) + color.charAt(1) + color.charAt(1) + color.charAt(2) + color.charAt(2)
    else throw ("Invalid hex color: " + color)  if color.length isnt 6
    rgb = []
    i = 0

    while i <= 2
      rgb[i] = parseInt(color.substr(i * 2, 2), 16)
      i++
    rgb

  contrastingColor : (color) ->
    (if (_luma(color) >= 165) then "000" else "fff")

  # url utilities
  urlGetStatusCode: (url, callback)->
    http.get(url, (res)->
      # console.log("Got response: " + res.statusCode);
      # console.dir res
      callback?(res.statusCode)
    ).on('error', (e)->
      console.error("Got error: " + e.message);
    );
  urlGetStatusCodeReadable: (url, callback)->
    @urlGetStatusCode url, (code)->
      readable = http.STATUS_CODES[code]
      # console.log readable
      callback readable


_luma = (color) -> # color can be a hx string or an array of RGB values 0-255
  rgb = (if (typeof color is "string") then methods.hexToRGBArray(color) else color)
  (0.2126 * rgb[0]) + (0.7152 * rgb[1]) + (0.0722 * rgb[2]) # SMPTE C, Rec. 709 weightings

# console.log methods
_.mixin methods
if typeof module isnt "undefined" then module.exports = _
